:- use_module(library(system)).

start_server :-
  exec('sicstus -r server.state',[pipe(ServerIn),pipe(ServerOut),std],
       ServerPID),
  asserta(server_in(ServerIn)),asserta(server_out(ServerOut)),
  nl,write('Server started: PID='),write(ServerPID),nl.

halt_server :-
  send(die).

translate(SourceWs,TargetWs) :-
  rec(SourceWs,Tag,SVs,Iqs),
  nl,write('Client has found parse: '),nl,pp_fs(Tag-SVs,Iqs),nl,
  send(fs(Tag,SVs,Iqs)),
  receive(Message),
  translate_act(Message,TargetWs).
translate(_,_) :-
  write('Client (parser) reports no more solutions.'),nl,
  fail.

translate_act(error,error) :-
  write('Server reports error.'),nl,abort.
translate_act(ws(TargetWs),TargetWs).
translate_act(ws(_),TargetWs) :-
  !,send(find_more),
  receive(Message),
  translate_act(Message,TargetWs).
translate_act(no_more,_) :-
  !,write('Server (generator) reports no more solutions.'),nl,
  fail.
translate_act(_,error) :-
  write('Client reports error.'),nl,abort.

translate(SourceWs) :-
  write('Translating: '),write_list(SourceWs),nl,
  translate(SourceWs,TargetWs),
  write('Translation: '),write_list(TargetWs),nl,
  query_proceed.

send(Message) :- 
  server_in(ServerIn),
  write(ServerIn,Message),write(ServerIn,'.'),nl(ServerIn).
receive(Message) :-
  server_out(ServerOut),
  read(ServerOut,Message).

